 'Autorange AD-Wandler
'AD Wert=1023  entspricht 4,092 V bei interner Uref = 2,048V
'Variante mit Treiber ULN2004

$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64

Dim D As Integer
Dim E As Integer
Dim F As Integer
Dim G As Integer
Dim H As Integer
Dim I As Integer
Dim J As Integer
Dim K As Integer
Dim L As Integer
Dim M As Integer
Dim N As Integer
Dim Zahl As Integer
Dim Pd As Byte
Dim Bereich As Byte
Dim Mb As Integer
Dim Stelle As Byte
Dim Durchlauf As Byte
Dim Xx As Byte

Declare Function Wandel(byval Zahl As Integer) As Byte
Declare Function Bereich(byval Mb As Integer) As Byte
Declare Sub Anzeige()

Config Portd = Output
Config Portb = Output

Ddrd = &B11111111                                           'Segmentausgaenge
Ddrb = &B11111111

Config Adc = Single , Prescaler = 64 , Reference = Off
 Start Adc


Portb = &H0CF
Portd = 0
Mb = 1

Do
  D = Getadc(0)
  D = D * 4

 Select Case D
   Case Is > 4010 : Mb = Mb + 1
   Case Is < 200 : Mb = Mb - 1
   Case Else : Mb = Mb
 End Select
 If Mb < 1 Then Mb = 1
 If Mb > 3 Then Mb = 3
 Xx = Bereich(mb )
 Portb = Portb Or Xx
 D = Getadc(0)
 D = D * 4

  Call Anzeige

Loop


Sub Anzeige()
  For Durchlauf = 1 To 20
  'Tausender Stelle
  If D >= 1000 Then
  E = D / 1000
  Else : E = 0
  End If
  Zahl = E
  Pd = Wandel(zahl)
  Portd = Pd
  Portb = Portb And &HF7
  Waitms 1
  Portb = Portb Or &H08
  'Hunderter Stelle
  F = E * 1000
  G = D - F
  If G >= 100 Then
  H = G / 100
  Else : H = 0
  End If
  Zahl = H
  Pd = Wandel(zahl)
  Portd = Pd
  Portb = Portb And &HFB
  Waitms 1
  Portb = Portb Or &H4
  'Zehner Stelle
  I = H * 100
  J = G - I
  If J >= 10 Then
  K = J / 10
  Else : K = 0
  End If
  Zahl = K
  Pd = Wandel(zahl)
  Portd = Pd
  Portb = Portb And &HFD
  Waitms 1
  Portb = Portb Or &H2
  'Einer Stelle
  L = K * 10
  M = J - L
  Zahl = M
  Pd = Wandel(zahl)
  Portd = Pd
  Portb = Portb And &HFE
  Waitms 1
  Portb = Portb Or &H1
  Next Durchlauf
End Sub

Function Wandel(byval Zahl As Integer) As Byte
Select Case Zahl
    Case 0 : Wandel = 63
    Case 1 : Wandel = 6
    Case 2 : Wandel = 91
    Case 3 : Wandel = 79
    Case 4 : Wandel = 102
    Case 5 : Wandel = 109
    Case 6 : Wandel = 124
    Case 7 : Wandel = 7
    Case 8 : Wandel = 127
    Case 9 : Wandel = 103
    Case Else : Wandel = 99
End Select
End Function

Function Bereich(byval Mb As Integer)as Byte
   Portb = Portb And &HCF
Select Case Mb
  Case 3 : Bereich = &H00
  Case 2 : Bereich = &H20
  Case 1 : Bereich = &H10
End Select
End Function